package at.hl.okb.wsclient;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import at.hl.wsclient.okb.Algorithm;
import at.hl.wsclient.okb.AlgorithmParameter;
import at.hl.wsclient.okb.ArrayOfAlgorithm;
import at.hl.wsclient.okb.ArrayOfAlgorithmParameter;
import at.hl.wsclient.okb.ArrayOfPlatform;
import at.hl.wsclient.okb.ArrayOfProblem;
import at.hl.wsclient.okb.IOKBService;
import at.hl.wsclient.okb.OKBService;
import at.hl.wsclient.okb.Platform;
import at.hl.wsclient.okb.Problem;

public class OKBServiceClient {
	OKBService srv = null;
	IOKBService port = null;

	public OKBServiceClient() {
		this.srv = new OKBService();
		this.port = srv.getWSHttpBindingIOKBService1();
	}  
	
	public Long getPlatformId(String platformName) {
		Long platformId = null;
		
		ArrayOfPlatform allPlatforms = port.getPlatforms();
		for (Platform platform:allPlatforms.getPlatform()) {
			if (platform.getName().getValue()==platformName) {
				platformId = platform.getId();
			}
		}
		return platformId;
	}

	public Long getAlgorithmId(String algorithmName) {
		Long algorithmId = null;
		
		ArrayOfAlgorithm allAlgorithms = port.getAlgorithms();
		for (Algorithm algo:allAlgorithms.getAlgorithm()) {
			if (algo.getName().getValue()==algorithmName) {
				algorithmId = algo.getId();
			}
		}
		return algorithmId;
	}
	
	public Long getProblemId(String problemName) {
		Long problemId = null;
		
		ArrayOfProblem allProblems = port.getProblems();
		for (Problem problem:allProblems.getProblem()) {
			if (problem.getName().getValue()==problemName) {
				problemId = problem.getId();
			}
		}
		return problemId;
	}

	public void checkAlgoParamsExists(Long algorithmId,
			Map<String, Object> algoParams) {
		
		List<String> missingParams = new ArrayList<String>();
		
		ArrayOfAlgorithmParameter allAlgoParams = port.getAlgorithmParameters(algorithmId);
		
//		for (AlgorithmParameter algoParam:allAlgoParams.getAlgorithmParameter()) {
//			if (algoParam.getName().getValue()==)
//		}
		
		
	}



}
